package it.eng.spago.jbi;

import java.util.logging.Level;
import java.util.logging.Logger;

import javax.jbi.JBIException;
import javax.jbi.component.Component;
import javax.jbi.component.ComponentContext;
import javax.jbi.component.ComponentLifeCycle;
import javax.jbi.messaging.DeliveryChannel;
import javax.jbi.messaging.MessageExchange;
import javax.jbi.messaging.MessagingException;
import javax.jbi.servicedesc.ServiceEndpoint;
import javax.management.ObjectName;

import org.w3c.dom.Document;
import org.w3c.dom.DocumentFragment;

public class SpagoComponent implements Component, ComponentLifeCycle {
    private ComponentContext mContext = null;

    private ServiceUnitManager mServiceUnitMgr = null;

    private DeliveryChannel mChannel = null;

    private SpagoMessageReceiver mMsgReceiver = null;

    public ComponentLifeCycle getLifeCycle() {
        return this;
    }

    public javax.jbi.component.ServiceUnitManager getServiceUnitManager() {
        return mServiceUnitMgr;
    }

    public Document getServiceDescription(ServiceEndpoint arg0) {
        // TODO Auto-generated method stub
        return null;
    }

    public boolean isExchangeWithConsumerOkay(ServiceEndpoint arg0, MessageExchange arg1) {
        return true;
    }

    public boolean isExchangeWithProviderOkay(ServiceEndpoint arg0, MessageExchange arg1) {
        return true;
    }

    public ServiceEndpoint resolveEndpointReference(DocumentFragment arg0) {
        // TODO Auto-generated method stub
        return null;
    }

    public ObjectName getExtensionMBeanName() {
        // TODO Auto-generated method stub
        return null;
    }

    public void init(ComponentContext compCtx) throws JBIException {
        if (compCtx != null) {
            mContext = compCtx;
            mServiceUnitMgr = new ServiceUnitManager(compCtx);
        }

    }

    public void shutDown() throws JBIException {
        mContext.getLogger(Constants.SPAGO_LOGGER, null).log(Level.INFO, "Shutting down component");
    }

    public void start() throws JBIException {
        Logger logger = mContext.getLogger(Constants.SPAGO_LOGGER, null);
        logger.log(Level.INFO, "Starting component");

        try {
            mChannel = mContext.getDeliveryChannel();
            mMsgReceiver = new SpagoMessageReceiver(mChannel, mContext);
            Thread recThrd = new Thread(mMsgReceiver);
            recThrd.start();
            logger.log(Level.INFO, "Component started");
        } catch (MessagingException me) {

        }
    }

    public void stop() throws JBIException {
        mContext.getLogger(Constants.SPAGO_LOGGER, null).log(Level.INFO, "Stopping component");
        mMsgReceiver.stopProcessing();
    }

}
